/*===============================================================*/

#include <stdio.h>
#include <assert.h>
#include "parti.h"

/*=================================================================
 * Function:   localize()
 *=================================================================*/

void  localize(  tabptr,
                 new_sched,  global_refs,  local_refs,  ndata,
                 no_off_proc,  my_size,  maxdim )

TTABLE *tabptr;
SCHED   **new_sched;
int      *global_refs;
int      *local_refs;
int       ndata;
int      *no_off_proc;
int       my_size;
int       maxdim;
{

  HASHSTR *hash_table;
  int      dont_care;
  int      stamp=0;
  int      combo_mask, supermask=NO_MASK; 
  int      range=100;
  int      i;
  double   dclock(), st, end;

  if (tableGetReplication(tabptr) >= 1.0)
    hash_table = (HASHSTR *) PARTI_create_rep_hash_table(tabptr);
  else
    hash_table = (HASHSTR *)PARTI_create_hash_table( range );
  assert( tabptr != NULL );
  for ( i=0 ; i< ndata; i++ ) local_refs[i] = global_refs[i];
  PARTI_hash( tabptr,  hash_table, supermask, &stamp,
              local_refs, ndata, my_size, no_off_proc, &dont_care);
  combo_mask = PARTI_make_mask( stamp );
  PARTI_schedule( hash_table, combo_mask, new_sched, maxdim);
/*
  print_com_pattern(new_sched);
*/
  PARTI_free_hash_table  ( hash_table );
  return;
}

/*=================================================================
 * Function:   reglocalize()
 *=================================================================*/

void  reglocalize(  dist,   data_range ,
                 new_sched,  global_refs,  local_refs,  ndata,
                 no_off_proc,  my_size,  maxdim )

int       dist;
int       data_range;
SCHED   **new_sched;
int      *global_refs;
int      *local_refs;
int       ndata;
int      *no_off_proc;
int       my_size;
int       maxdim;
{

  TTABLE   *tabptr = NULL;
  HASHSTR  *hash_table;
  int       dont_care;
  int       stamp=0; 
  int       combo_mask, supermask=NO_MASK; 
  int       range;
  int       i;
  double    dclock(), st, end;

      hash_table = (HASHSTR *)PARTI_create_hash_table( data_range );
      tabptr     = (TTABLE  *)build_reg_translation_table( dist, data_range );
      assert( tabptr != NULL );
      for ( i=0 ; i< ndata; i++ ) local_refs[i] = global_refs[i];
      PARTI_hash( tabptr,  hash_table, supermask, &stamp,
                  local_refs, ndata, my_size, no_off_proc, &dont_care);

      combo_mask = PARTI_make_mask( stamp );

      PARTI_schedule( hash_table, combo_mask, new_sched, maxdim);
/*
      print_com_pattern(*new_sched);
*/
      PARTI_free_hash_table  ( hash_table );
      return;
}




